package com.ruoyi.product.controller;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.product.domain.pojo.ProductClassifyPO;
import com.ruoyi.product.domain.vo.ProductClassifyVo;
import com.ruoyi.product.service.ProductClassifyService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import java.util.List;

@RestController
@RequestMapping("/classify")
@Api(tags = "商品分类操作")
public class ClassifyController {

    @Autowired
    private ProductClassifyService productClassifyService;

    /**
     * 思路:
     * 1.查询所有一级分类集合
     * 2.根据一级分类对应的ID查询其对应的子类集合
     * 3.本次不进行后台分页,采用纯前台分页
     * @return
     */

    @GetMapping("/getAllFirst")
    @ApiOperation("查询一级分类")
    public R<List<ProductClassifyPO>> getAllFirst(){
        return productClassifyService.getAllFirst();
    }

    @PostMapping("/getAllSecond")
    @ApiOperation("查询二级分类(指定一级分类的子集)")
    public R<List<ProductClassifyPO>>getAllSecond(@RequestParam Integer parentId ){
        return productClassifyService.getAllSecond(parentId);
    }


    @GetMapping("/getAll")
    @ApiOperation("获取商品全部分类")
    public R<List<ProductClassifyVo>> getAll(){
        return R.ok(productClassifyService.getAll());
    }
}
