package com.ruoyi.product.controller;
import com.ruoyi.common.core.domain.PageResult;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.domain.Result;
import com.ruoyi.product.domain.req.ProductBrand;
import com.ruoyi.product.domain.req.ProductGuaranteeReq;
import com.ruoyi.product.domain.req.ProductInfoReq;
import com.ruoyi.product.domain.vo.BulkVo;
import com.ruoyi.product.domain.vo.ProductVo;
import com.ruoyi.product.service.JingTaoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/jingtao")
public class JingTaoController {
    @Autowired
    private JingTaoService service;
    /**
     * 商品服务保证中间表的增删改应当附属商品进行增删改.
     * 即对商品表进行操作时要对中间表进行改动
     */


    /**
     * 商品列表
     */
    @PostMapping("/queryProductList")
    public Result<PageResult<ProductInfoReq>> queryProductList(@RequestBody ProductVo vo){
        return service.queryProductList(vo);
    }

    /**
     *删除商品(逻辑删除在Mapper层将is_delete修改为2,传参为商品id)
     */
    @PostMapping("/updateProductIsDelete")
    public R updateProductIsDelete(@RequestParam Integer productId){
        return service.updateProductIsDelete(productId);
    }

    /**
     * 批量操作 上架,新品,推荐
     */
    @PostMapping("/bulkOperation")
    public R bulkOperation(@RequestBody BulkVo bulkVo){
        return service.bulkOperation(bulkVo);
    }

    /**
     * 商品品牌
     */
    @GetMapping("/queryProductBrand")
    public R<List<ProductBrand>>queryProductBrand(){
        return service.queryProductBrand();
    }

    /**
     * 查询服务保证:1.无忧退货 2.快速退款 3.免费包邮
     */
    @GetMapping("/queryGuaranteeService")
    public R<List<ProductGuaranteeReq>>queryGuaranteeService(){
        return service.queryGuaranteeService();
    }

    /**
     * 添加商品
     */
    @PostMapping("/addProduct")
    public R addProduct(@RequestBody ProductInfoReq req){
        return service.addProduct(req);
    }

    /**
     * 修改商品
     */
    @PostMapping("/updateProduct")
    public R updateProduct(@RequestBody ProductInfoReq req){
        return service.updateProduct(req);
    }

    /**
     * 添加商品品牌
     */
    @PostMapping("/addProductBrand")
    public R addProductBrand(@RequestBody ProductBrand brand){
        return service.addProductBrand(brand);
    }

    /**
     * 回显,根据id查询指定商品信息
     */
    @PostMapping("/queryThisProduct")
    public R<ProductInfoReq> queryThisProduct(@RequestParam Long id){
        return service.queryThisProduct(id);
    }








}
