package com.ruoyi.product.service.impl;

import com.ruoyi.common.core.domain.R;
import com.ruoyi.product.domain.req.ProductBrand;
import com.ruoyi.product.mapper.JingTaoBrandMapper;
import com.ruoyi.product.service.JingTaoBrandService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class JingTaoBrandServiceImpl implements JingTaoBrandService {
    @Autowired
    private JingTaoBrandMapper brandMapper;

    @Override
    public R addProductBrand(ProductBrand brand) {
        int i = brandMapper.addProductBrand(brand);
        if (i<=0){
            return R.fail("添加品牌失败");
        }

        return R.ok(i,"添加品牌成功");
    }

    @Override
    public R updateBrand(ProductBrand brand) {
        int i = brandMapper.updateBrand(brand);
        if (i<=0){
            return R.fail("修改品牌失败");
        }

        return R.ok(i,"修改品牌成功");
    }

    @Override
    public R updateBrandState(Integer id) {
        int i = brandMapper.updateBrandState(id);
        if (i<=0){
            return R.fail("删除品牌失败");
        }

        return R.ok(i,"删除品牌成功");

    }

    @Override
    public R<List<ProductBrand>> queryBrand(String brandParameter) {
        List<ProductBrand> productBrandList =  brandMapper.queryBrand(brandParameter);
        return R.ok(productBrandList,"品牌列表");
    }
}
