package com.ruoyi.product.service.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ruoyi.common.core.domain.PageResult;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.domain.Result;
import com.ruoyi.product.domain.req.ProductBrand;
import com.ruoyi.product.domain.req.ProductGuaranteeReq;
import com.ruoyi.product.domain.req.ProductInfoReq;
import com.ruoyi.product.domain.vo.BulkVo;
import com.ruoyi.product.domain.vo.ProductVo;
import com.ruoyi.product.mapper.JingTaoMapper;
import com.ruoyi.product.service.JingTaoService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@Log4j2
public class JingTaoServiceImpl implements JingTaoService {
    @Autowired
    private JingTaoMapper mapper;
    @Override
    public Result<PageResult<ProductInfoReq>> queryProductList(ProductVo vo) {
        PageHelper.startPage(vo.getPageNum(), vo.getPageSize());
        List<ProductInfoReq> productInfoReqList = mapper.queryProductList(vo);
        PageInfo<ProductInfoReq> info = new PageInfo<>();
        return PageResult.toResult(info.getTotal(),productInfoReqList);
    }

    @Override
    public R updateProductIsDelete(Integer productId) {
        int i  = mapper.updateProductIsDelete(productId);
        if (i<=0){
            return R.fail("删除失败,请稍后再试");
        }
        return R.ok(i,"删除成功");
    }

    @Override
    public R bulkOperation(BulkVo bulkVo) {
        //修改状态: 商品上架 商品下架  设为推荐 取消推荐  设为新品 取消新品
        if (bulkVo.getVoValueName().equals("商品上架")){
            int i  = mapper.bulkOperation1(bulkVo);
            if (i<=0){
                return R.fail("操作失败,请稍后再试");
            }
            return R.ok(i,"操作成功");
        }
        if (bulkVo.getVoValueName().equals("商品下架")){
            int i  = mapper.bulkOperation2(bulkVo);
            if (i<=0){
                return R.fail("操作失败,请稍后再试");
            }
            return R.ok(i,"操作成功");
        }
        if (bulkVo.getVoValueName().equals("设为推荐")){
            int i  = mapper.bulkOperation3(bulkVo);
            if (i<=0){
                return R.fail("操作失败,请稍后再试");
            }
            return R.ok(i,"操作成功");
        }
        if (bulkVo.getVoValueName().equals("取消推荐")){
            int i  = mapper.bulkOperation4(bulkVo);
            if (i<=0){
                return R.fail("操作失败,请稍后再试");
            }
            return R.ok(i,"操作成功");
        }
        if (bulkVo.getVoValueName().equals("设为新品")){
            int i  = mapper.bulkOperation5(bulkVo);
            if (i<=0){
                return R.fail("操作失败,请稍后再试");
            }
            return R.ok(i,"操作成功");
        }
        if (bulkVo.getVoValueName().equals("取消新品")){
            int i  = mapper.bulkOperation6(bulkVo);
            if (i<=0){
                return R.fail("操作失败,请稍后再试");
            }
            return R.ok(i,"操作成功");
        }
        return R.ok();
    }

    @Override
    public R<List<ProductBrand>> queryProductBrand() {
        List<ProductBrand> brandList = mapper.queryProductBrand();
        log.info(brandList);
        return R.ok(brandList,"查询品牌列表成功");
    }

    @Override
    public R addProduct(ProductInfoReq req) {



        int i = mapper.addProduct(req);
        return null;
    }

    @Override
    public R updateProduct(ProductInfoReq req) {
        int i = mapper.updateProduct(req);
        return null;
    }

    @Override
    public R addProductBrand(ProductBrand brand) {
        int i  =  mapper.addProductBrand(brand);
        if (i<=0){
            return R.fail("添加品牌失败");
        }
        return R.ok(i,"添加品牌成功");
    }

    @Override
    public R<ProductInfoReq> queryThisProduct(Long id) {
        ProductInfoReq req = mapper.queryThisProduct(id);
        return null;
    }

    @Override
    public R<List<ProductGuaranteeReq>> queryGuaranteeService() {
        List<ProductGuaranteeReq> reqList = mapper.queryGuaranteeService();
        return R.ok(reqList,"查询服务保证");
    }


}
